"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.HttpClientResponse = exports.HttpClientGenericResponse = exports.HttpClient = void 0;
class HttpClient {
    makeRequest(url, { headers, method, protocol, requestData, timeout }) {
        throw new Error('makeRequest not implemented.');
    }
    static makeTimeoutError() {
        const timeoutErr = new TypeError(HttpClient.TIMEOUT_ERROR_CODE);
        timeoutErr.code = HttpClient.TIMEOUT_ERROR_CODE;
        return timeoutErr;
    }
}
exports.HttpClient = HttpClient;
HttpClient.CONNECTION_CLOSED_ERROR_CODES = ['ECONNRESET', 'EPIPE'];
HttpClient.TIMEOUT_ERROR_CODE = 'ETIMEDOUT';
class HttpClientGenericResponse {
    constructor(statusCode, headers) {
        this._statusCode = statusCode;
        this._headers = headers;
    }
    getStatusCode() {
        return this._statusCode;
    }
    getHeaders() {
        return this._headers;
    }
    getRawResponse() {
        throw new Error('getRawResponse not implemented.');
    }
    toStream(streamCompleteCallback) {
        throw new Error('toStream not implemented.');
    }
    toJSON() {
        throw new Error('toJSON not implemented.');
    }
}
exports.HttpClientGenericResponse = HttpClientGenericResponse;
class HttpClientResponse {
    constructor(response) {
        this._res = response;
    }
    getStatusCode() {
        throw new Error('getStatusCode not implemented.');
    }
    getHeaders() {
        throw new Error('getHeaders not implemented.');
    }
    getRawResponse() {
        throw new Error('getRawResponse not implemented.');
    }
    toStream(streamCompleteCallback) {
        throw new Error('toStream not implemented.');
    }
    toJSON() {
        throw new Error('toJSON not implemented.');
    }
}
exports.HttpClientResponse = HttpClientResponse;
